# heckel.pl : Compute difference sets between two array of string.
# Ver 1.01 Jun. 23 2004 written by MIZUTANI Tociyuki

# [2005/06/21] mymixi_historypɎ኱̕ύXBby Hamachiya2
# JɂIWiheckel.pĺA
# ̃TCg[http://tociyuki.cool.ne.jp/]_E[hł܂B

{
	package DiffHeckel;
	use integer;

	sub diff {
		my($A, $B) = @_;
		my @Diffs;
		my @Auniq = ([ -1, -1 ], [ scalar( @$A ), scalar( @$B ) ]);
		my(%Freq, %Ap, %Bp, $s, $x);
		for $x (0..$#$A) { $s = $$A[ $x ]; $Freq{ $s } += 2; $Ap{ $s } = $x; }
		for $x (0..$#$B) { $s = $$B[ $x ]; $Freq{ $s } += 3; $Bp{ $s } = $x; }
		while ( ( $s, $x ) = each %Freq ) {
			push @Auniq, [ $Ap{ $s }, $Bp{ $s } ] if $x == 5;
		}
		@Auniq = sort { $$a[0] <=> $$b[0] } @Auniq;
		my($Alast, $Blast) = ($#$A, $#$B);
		my($ax, $bx, $an, $bn) = (0, 0, -1, -1);
		while ($ax <= $Alast && $bx <= $Blast && $$A[ $ax ] eq $$B[ $bx ]) {
			$ax++; $bx++;
		}
		my($Afirst, $Bfirst) = ($ax, $bx);
		for (@Auniq) {
			($an, $bn) = @$_;
			next if $an < $Afirst || $bn < $Bfirst;
			( $ax, $bx ) = ( $an - 1, $bn - 1 );
			while ($ax >= $Afirst && $bx >= $Bfirst && $$A[$ax] eq $$B[$bx]) {
				$ax--; $bx--;
			}
			if ( $ax >= $Afirst && $bx >= $Bfirst ) {
				push @Diffs, [ 'c', $Afirst, $ax, $Bfirst, $bx ];
			} elsif ( $ax >= $Afirst ) {
				push @Diffs, [ 'd', $Afirst, $ax, $Bfirst, $Bfirst ];
			} elsif ( $bx >= $Bfirst ) {
				push @Diffs, [ 'a', $Afirst, $Afirst, $Bfirst, $bx ];
			}
			($ax, $bx) = ($an + 1, $bn + 1);
			while ($ax <= $Alast && $bx <= $Blast && $$A[$ax] eq $$B[$bx]) {
				$ax++; $bx++;
			}
			($Afirst, $Bfirst) = ($ax, $bx);
		}
		\@Diffs;
	}

1;
} # end package DiffHeckel

{
	package DiffFormatter;
	use integer;

	sub unified {
		my @ret;

		my($Diffs, $A, $B) = @_;
		my $adot = 0;
		for (@$Diffs) {
			my($c, $aa, $az, $ba, $bz) = @$_;
			unless ($c eq 'a') {
				push(@ret, "-". $$A[ $_ ]) for ($aa .. $az);
			}
			unless ($c eq 'd') {
				push(@ret, "+". $$B[ $_ ]) for ($ba .. $bz);
			}
			$adot = $az + ($c eq 'a' ? 0 : 1);
		}
		return @ret;
	}

	1;
} # end package DiffFormatter


__END__
=head1 NAME

heckel.pl : Compute difference sets between two array of string.
Ver 1.01 Jun. 23 2004 written by MIZUTANI Tociyuki

=head1 REFERENCE

P. Heckel. ``A technique for isolating differences between files.''
Communications of the ACM, Vol. 21, No. 4, page 264, April 1978.

=head1 AUTHOR

MIZUTANI, Tociyuki
<http://tociyuki.cool.ne.jp/> - Sorry Japanese only.

=head1 COPYRIGHT AND LICENCE

Copyright (c) 2004 MIZUTANI Tociyuki All Rights Reserved.

This is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

=cut
